<?php
/* --------------------------------------------------------------
   dependent.inc.php 2018-10-19
   Gambio GmbH
   http://www.gambio.de
   Copyright © 2018 Gambio GmbH
   Released under the GNU General Public License (Version 2)
   [http://www.gnu.org/licenses/gpl-2.0.html]
   --------------------------------------------------------------
*/

// Ensure that disconnected Hub clients have the "False" HubConnector status set, in order to avoid unnecessary requests towards Hub. 
$check_configuration = $this->query('SELECT * FROM `configuration` WHERE `configuration_key` = "MODULE_PAYMENT_GAMBIO_HUB_STATUS" AND `configuration_value` = "True"', true);
$check_gm_configuration = $this->query('SELECT * FROM `gm_configuration` WHERE `gm_key` = "GAMBIO_HUB_CLIENT_KEY" AND `gm_value` = ""', true);
if($check_configuration->num_rows > 0 && $check_gm_configuration->num_rows > 0)
{
	$query = ' 
        UPDATE `configuration` SET
            `configuration_value` = "False"
        WHERE
            `configuration_key` = "MODULE_PAYMENT_GAMBIO_HUB_STATUS"';
	
	$t_success &= $this->query($query) > 0;
}

// add default GALLERY_LIGHTBOX option
$check = $this->query('SELECT * FROM `gm_configuration` WHERE `gm_key` = "GALLERY_LIGHTBOX"', true);
if($check->num_rows < 1)
{
	$query = 'INSERT INTO `gm_configuration` SET `gm_key` = "GALLERY_LIGHTBOX", `gm_value` = "false"';
	$t_success &= $this->query($query) > 0;
}

// add default SHOW_WHATSAPP option
$check = $this->query('SELECT * FROM `gm_configuration` WHERE `gm_key` = "SHOW_WHATSAPP"', true);
if($check->num_rows < 1)
{
	$query = 'INSERT INTO `gm_configuration` SET `gm_key` = "SHOW_WHATSAPP", `gm_value` = "false"';
	$t_success &= $this->query($query) > 0;
}


$check = $this->query('SELECT * FROM `configuration_storage` WHERE `key` LIKE "modules/GambioSunnyCash/%"', true);
if($check->num_rows < 1)
{
	$check = $this->query('SELECT * FROM `configuration_storage` WHERE `key` LIKE "modules/GambioOvisto/%"', true);
	if($check->num_rows > 0)
	{
		$query = 'UPDATE `configuration_storage` SET `key` = REPLACE(`key`, "modules/GambioOvisto/", "modules/GambioSunnyCash/") WHERE `key` LIKE "modules/GambioOvisto/%"';
		$t_success &= $this->query($query) > 0;
	}
	else
	{
		$query = 'INSERT INTO `configuration_storage` SET `key` = "modules/GambioSunnyCash/active", `value` = "1"';
		$t_success &= is_numeric($this->query($query));
	}
}


$check = $this->query('SELECT * FROM `gm_configuration` WHERE `gm_key` = "MODULE_CENTER_GAMBIOSUNNYCASH_INSTALLED"', true);
if($check->num_rows < 1)
{
	$check = $this->query('SELECT * FROM `gm_configuration` WHERE `gm_key` = "MODULE_CENTER_GAMBIOOVISTO_INSTALLED"', true);
	if($check->num_rows > 0)
	{
		$query = 'UPDATE `gm_configuration` SET `gm_key` = "MODULE_CENTER_GAMBIOSUNNYCASH_INSTALLED" WHERE `gm_key` = "MODULE_CENTER_GAMBIOOVISTO_INSTALLED"';
		$t_success &= $this->query($query) > 0;
	}
	else
	{
		$query = 'INSERT INTO `gm_configuration` SET `gm_key` = "MODULE_CENTER_GAMBIOSUNNYCASH_INSTALLED", `gm_value` = "1"';
		$t_success &= $this->query($query) > 0;
	}
}

$customerIdsWithoutCustomerGroup = $this->query('SELECT customers_id FROM customers WHERE customers_status NOT IN (SELECT customers_status_id From customers_status)',
                                                true);

if($customerIdsWithoutCustomerGroup->num_rows > 0)
{
	$defaultCustomerGroupId = $this->query('SELECT configuration_value FROM configuration WHERE configuration_key = "DEFAULT_CUSTOMERS_STATUS_ID"')[0];
	
	foreach($customerIdsWithoutCustomerGroup as $customerId)
	{
		$this->query('UPDATE customers SET customers_status = ' . (int)$defaultCustomerGroupId['configuration_value']
		             . ' WHERE customers_id = ' . (int)$customerId['customers_id']);
	}
}